var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var path = require('path');
var HtmlWebpackPlugin = require('html-webpack-plugin');
var CopyWebpackPlugin = require('copy-webpack-plugin');
var WebpackPluginImport = require('webpack-plugin-import');
var _a = require('./utils'), getFilePath = _a.getFilePath, getWebOutputPath = _a.getWebOutputPath;
module.exports = function (api, _a) {
    var target = _a.target, webpackConfig = _a.webpackConfig;
    var context = api.context;
    var rootDir = context.rootDir;
    var outputPath = getWebOutputPath(context, { target: target });
    webpackConfig
        // SimpleProgressPlugin
        .plugin('SimpleProgressPlugin')
        .tap(function (_a) {
        var args = _a[0];
        return [__assign(__assign({}, args), { progressOptions: {
                    clear: true,
                    callback: function () {
                        console.log();
                    }
                } })];
    })
        .end()
        // HtmlWebpackPlugin
        .plugin('HtmlWebpackPlugin')
        .use(HtmlWebpackPlugin, [{
            inject: true,
            templateParameters: {
                NODE_ENV: process.env.NODE_ENV,
            },
            favicon: getFilePath([
                path.join(rootDir, 'public/favicon.ico'),
                path.join(rootDir, 'public/favicon.png'),
            ]),
            template: path.resolve(rootDir, 'public/index.html'),
            minify: false,
        }])
        .end()
        // CopyWebpackPlugin
        .plugin('CopyWebpackPlugin')
        .use(CopyWebpackPlugin, [{
            patterns: [
                {
                    from: path.resolve(rootDir, 'public'),
                    to: path.resolve(rootDir, outputPath),
                    noErrorOnMissing: true,
                    globOptions: {
                        dot: true,
                        gitignore: true,
                        ignore: ['**/public/index.html'],
                    },
                },
            ]
        }])
        .end()
        // WebpackPluginImport
        .plugin('WebpackPluginImport')
        .use(WebpackPluginImport, [[
            {
                libraryName: /@ali\/ice-.*/,
                stylePath: 'style.js',
            },
        ]])
        .end();
    webpackConfig.resolve.merge({
        conditionNames: ['web'],
    });
    return webpackConfig;
};
//# sourceMappingURL=setBase.js.map